/****************************************************
*
* Guyet T.
* IFSIC - M2 GL - 2009-2010
*
* TD1_exo3.cc : Exemple de manipulation des connections de signaux
*
****************************************************/

#include <iostream>
#include "gtkmm.h"

void on_button_clicked()
{
	std::cout << "fonction globale\n";
};

class SomeButton : public Gtk::Button
{
	public:
	 SomeButton (const Glib::ustring& label, bool mnemonic=false) : Gtk::Button(label,mnemonic) {};
	 
    void on_clicked() {
    	std::cout << "fonction on_clicked() de "<< get_label() <<"\n";
    }
	 
    void on_button_clicked() {
    	std::cout << "fonction on_button_clicked() de "<< get_label() <<"\n";
    }
};

class some_class
{
public:
    void on_button_clicked() {
    	std::cout << "fonction on_button_clicked de some_class\n";
    };
};

some_class some_object;
 
int main(int argc, char** argv)
{
  Gtk::Main kit(argc, argv);
  
  // Construction de la fenêtre
  Gtk::Window fenetre;
  fenetre.set_title("ma fenetre");
  Gtk::HBox bH;
  fenetre.add(bH);
  Gtk::Button buttonA("A");
  Gtk::Button buttonB("B");
  //Gtk::Button buttonC("C");
  SomeButton buttonD("D");
  SomeButton buttonE("E");
  SomeButton buttonF("F");
  bH.pack_start(buttonA);
  bH.pack_start(buttonB);
  //bH.pack_start(buttonC);
  bH.pack_start(buttonD);
  bH.pack_start(buttonE);
  bH.pack_start(buttonF);
  
  //Affichage des widgets
  fenetre.show_all();
  
  // Connexions
  buttonA.signal_clicked().connect( sigc::ptr_fun(&on_button_clicked) );
  buttonB.signal_clicked().connect( sigc::mem_fun(some_object, &some_class::on_button_clicked) );
  //buttonC.signal_clicked().connect( sigc::ptr_fun(&some_class::on_button_clicked) ); // -> Ce n'est pas possible !
  buttonE.signal_clicked().connect( sigc::mem_fun(buttonE, &SomeButton::on_button_clicked) );
  buttonF.signal_clicked().connect( sigc::mem_fun(buttonF, &SomeButton::on_button_clicked) );
  
  //Lancement de la fenêtre
  Gtk::Main::run(fenetre);
  return 0;
}

