/****************************************************
*
* Guyet T.
* IFSIC - M2 GL - 2009-2010
*
* TD1_exo4.cc : Exemple de manipulation des signaux avec binding
*
****************************************************/

#include <iostream>
#include "gtkmm.h"

void on_button_clicked(Glib::ustring str)
{
	std::cout << "fonction clicked (" << str << ")\n";
};

bool on_button_pressed(GdkEventButton*)
{
	std::cout << "fonction pressed \n";
}


bool on_button_released(GdkEventButton*, Glib::ustring str, int t)
{
	std::cout << "fonction pressed (" << str << ", "<< t << ")\n";
}
 
int main(int argc, char** argv)
{
  Gtk::Main kit(argc, argv);
  
  // Construction de la fenêtre
  Gtk::Window fenetre;
  fenetre.set_title("ma fenetre");
  Gtk::HBox bH;
  fenetre.add(bH);
  Gtk::Button buttonA("A");
  bH.pack_start(buttonA);
  
  Gtk::DrawingArea widg;
  bH.pack_start(widg);
  widg.add_events(Gdk::BUTTON_PRESS_MASK | Gdk::BUTTON_RELEASE_MASK);
  
  //Affichage des widgets
  fenetre.show_all();

  //Connexions
  buttonA.signal_clicked().connect( sigc::bind<Glib::ustring>( sigc::ptr_fun(on_button_clicked), "button") );
  widg.signal_button_press_event().connect( sigc::ptr_fun(on_button_pressed) );
  widg.signal_button_release_event().connect( sigc::bind<Glib::ustring, int>( sigc::ptr_fun(on_button_released), "bouton", 34 ) );

  //Lancement de la fenêtre
  Gtk::Main::run(fenetre);
  return 0;
}

